/*
 * Copyright 2002-2009 Sferyx Srl. All rights reserved.
 * HTMLEditorTestListeners.java
 *
 * Created on 12 February 2004, 08:13
 */
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import sferyx.administration.editors.*;
import javax.swing.text.*;
/**
 *This example shows how to add various listeners to the editor
 *
 */
public class HTMLEditorTestListeners extends JFrame implements FocusListener, DocumentListener{
    HTMLEditor htmlEditor;
    JTextArea textArea;
    
    public static void main(String args[]) 
    {
        new HTMLEditorTestListeners();

    }

    public void focusGained(FocusEvent e) 
    {
        textArea.append("Editor --> Focus gained\n");
    }

    public void focusLost(FocusEvent e) 
    {
        textArea.append("Editor --> Focus lost\n");
    }

    public void changedUpdate(javax.swing.event.DocumentEvent documentEvent)
    {
        textArea.append("Document --> Changed\n");
    }

    public void insertUpdate(javax.swing.event.DocumentEvent documentEvent) 
    {
        textArea.append("Document --> Inserted\n");
    }

    public void removeUpdate(javax.swing.event.DocumentEvent documentEvent)
    {
        textArea.append("Document --> Removed\n");
    }

    /** Creates a new instance of HTMLEditorTest */
    public HTMLEditorTestListeners() 
    {
        
         try
      {
        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      }
      catch(Exception exc)
      {
      }
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        
        Container con = getContentPane();
        JSplitPane split=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
        htmlEditor = new HTMLEditor();
        textArea = new JTextArea();//JEditorPane();
        
        Dimension minimumSize = new Dimension(50, 50);
        htmlEditor.setMinimumSize(minimumSize);
        textArea.setMinimumSize(minimumSize);
        JScrollPane scrollPane=new JScrollPane(textArea);
        scrollPane.setBorder(new TitledBorder("Log area:"));
        split.add(htmlEditor);
        split.add(scrollPane);
        split.setDividerLocation(600);
        
        htmlEditor.setContent("Hello, type something - this is a document and focus listeners test");
        htmlEditor.getInternalJEditorPane().addFocusListener(this);
        htmlEditor.addDocumentListener(this);
        con.add(split);
        pack();
	setSize(900,600);
        setLocation(Toolkit.getDefaultToolkit().getScreenSize().width/2-getWidth()/2,Toolkit.getDefaultToolkit().getScreenSize().height/2-getHeight()/2);
        setVisible(true);
    }



}
