/*
 * Copyright 2002-2009 Sferyx Srl. All rights reserved.
 * ReferencingDocumentElements.java
 *
 *
 */
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.*;
import sferyx.administration.editors.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import sferyx.javascript.engine.*;
/**
 *
 * @author  Vassil Boyadjiev
 */
public class ReferencingDocumentElements extends JFrame implements MouseListener {

    /** Creates new form ReferencingDocumentElements */
    public ReferencingDocumentElements() 
    {
        
        
        initComponents();
        hTMLEditor1.setContent("<form id=\"11\"><input type=\"submit\" name=\"my_button\" id=\"3246\" value=\"test button\"></form> <b>Use the buttons below to retrieve the form elements. Click on \"Add Listerner to Button\" to capture the events from the form buttons</b>");
        hTMLEditor1.setSourceEditorVisible(false);
        hTMLEditor1.setPreviewVisible(false);
        jsEngine=new JavaScriptEmulatorEngine(hTMLEditor1);
        setSize(970,600);
        setLocation(java.awt.Toolkit.getDefaultToolkit().getScreenSize().width/2-getWidth()/2,java.awt.Toolkit.getDefaultToolkit().getScreenSize().height/2-getHeight()/2);
    }
 
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {
    	mainPanel = new javax.swing.JPanel();
    	mainPanel.setLayout(new java.awt.BorderLayout());
        hTMLEditor1 = new sferyx.administration.editors.HTMLEditor();
        buttonsPanel = new javax.swing.JPanel();
        printFormElements = new javax.swing.JButton();
        getByIDButton = new javax.swing.JButton();
        getByTagButton = new javax.swing.JButton();
        addMouseListenerButton = new javax.swing.JButton();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        hTMLEditor1.setRemovedMenuItems("");
        hTMLEditor1.setStatusMessage("");
        hTMLEditor1.setTableItemsStatus(false);
        mainPanel.add(hTMLEditor1, java.awt.BorderLayout.CENTER);

        printFormElements.setText("Print Form Elements");
        printFormElements.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                printFormElementsActionPerformed(evt);
            }
        });

        buttonsPanel.add(printFormElements);

        getByIDButton.setText("Get Elements by ID");
        getByIDButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                getByIDButtonActionPerformed(evt);
            }
        });

        buttonsPanel.add(getByIDButton);

        getByTagButton.setText("Get Elements by Tag");
        getByTagButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                getByTagButtonActionPerformed(evt);
            }
        });

        buttonsPanel.add(getByTagButton);

        addMouseListenerButton.setText("Add Mouse Listener to Button");
        addMouseListenerButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addMouseListenerButtonActionPerformed(evt);
            }
        });

        buttonsPanel.add(addMouseListenerButton);

        mainPanel.add(buttonsPanel, java.awt.BorderLayout.SOUTH);
        logArea=new JTextArea();
        JSplitPane split=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
        JScrollPane scrollPane=new JScrollPane(logArea);
        scrollPane.setBorder(new TitledBorder("Log area:"));
        split.add(mainPanel);
        split.add(scrollPane);
        split.setDividerLocation(600);
        Dimension minimumSize = new Dimension(50, 50);
	mainPanel.setMinimumSize(minimumSize);
        logArea.setMinimumSize(minimumSize);
        
        getContentPane().add(split);

        pack();
    }

    private void addMouseListenerButtonActionPerformed(java.awt.event.ActionEvent evt) {
        // Add your handling code here:
        attachMouseListenerToComponent();
    }

    private void getByTagButtonActionPerformed(java.awt.event.ActionEvent evt) {
        // Add your handling code here:
        printElementsByTag();
    }

    private void getByIDButtonActionPerformed(java.awt.event.ActionEvent evt) {
        // Add your handling code here:
        printElementsByID();
    }

    private void printFormElementsActionPerformed(java.awt.event.ActionEvent evt) {
        // Add your handling code here:
        printFormElements();
    }

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {
        System.exit(0);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        
         
         try
      {
        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      }
      catch(Exception exc)
      {
      } 
        
       ReferencingDocumentElements frame=new ReferencingDocumentElements();
       frame.show();
    }

    public void mouseClicked(java.awt.event.MouseEvent mouseEvent) {
    }

    public void mouseEntered(java.awt.event.MouseEvent mouseEvent) {
    }

    public void mouseExited(java.awt.event.MouseEvent mouseEvent) {
    }

    public void mousePressed(java.awt.event.MouseEvent mouseEvent) {
    }

    public void mouseReleased(java.awt.event.MouseEvent mouseEvent)
    {

       // System.out.println();
        logArea.append("==> Mouse Released:"+mouseEvent+"\n");
       
    }

    
    public void printFormElements()
    {
        
         
       // Note that if there are no forms, the "forms" property will be null. Handle this accordingly
        // In these case use the alternative ways are to use the getElementById, getElementsByTagName or getElementsByName
        if(jsEngine.getDocument().forms==null)
        {
            
            //System.out.println("No form elements in the document");
            logArea.append("No form elements in the document"+"\n");
            return;
            
        }
         
        DocumentElement[] elements=jsEngine.getDocument().forms[0].elements;
     
     
        for(int i=0;i<elements.length;i++)
        {
           /* System.out.println("------Element Start---------");
            System.out.print(elements[i]);
            System.out.println("------Element End---------");
            */
            
            logArea.append("------Element Start---------"+"\n");
            logArea.append(elements[i]+"\n");
            logArea.append("------Element End---------"+"\n");
            
        }
        
        
    }
    
    public void printElementsByID()
    {
        
        
        //Will return the element with specified ID attribute
        
            DocumentElement element=jsEngine.getDocument().getElementById("3246");
         
        /*
            System.out.println("------Element Start---------");
            System.out.print(element);
            System.out.println("------Element End---------");
         */
        
            logArea.append("------Element Start---------"+"\n");
            logArea.append(element+"\n");
            logArea.append("------Element End---------"+"\n");
        
        
    }

    
    public void printElementsByTag()
    {
        
        //Will return all elements with specified tag
        
        
        DocumentElement[] elements=jsEngine.getDocument().getElementsByTagName("INPUT");
       //   DocumentElement[] elements=jsEngine.getDocument().getElementsByTagName("IMG");
         if(elements==null)
         {
             logArea.append("No form elements in the document"+"\n");
             return;
         }

        for(int i=0;i<elements.length;i++)
        {
           /* System.out.println("------Element Start---------");
            System.out.print(elements[i]);
            System.out.println("------Element End---------");
            */
            
              
            logArea.append("------Element Start---------"+"\n");
            logArea.append(elements[i]+"\n");
            logArea.append("------Element End---------"+"\n");
        }
        
        
    }
    
    
    
    public void attachMouseListenerToComponent()
    {
     
        //Will attach a mouse listener to an element with specified ID attribute.
        
              DocumentElement element=jsEngine.getDocument().getElementById("3246");                   
              JComponent component=SferyxUtilities.getJavaFormItemComponent(element, hTMLEditor1);
              //System.out.println("Adding Mouse Listener to :"+component);
              logArea.append("Adding Mouse Listener to :"+component+"\n");
              component.addMouseListener(this);
        
    }
    
    

    // Variables declaration - do not modify
    private javax.swing.JButton getByIDButton;
    private javax.swing.JPanel buttonsPanel;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JButton addMouseListenerButton;
    private sferyx.administration.editors.HTMLEditor hTMLEditor1;
    private javax.swing.JButton getByTagButton;
    private javax.swing.JButton printFormElements;
    // End of variables declaration

    
    JTextArea logArea;
    JavaScriptEmulatorEngine jsEngine;
    
}


